-- 地图界面
checkRequire("Lua_WorldMapPanel");
checkRequire("Lua_SceneMapPanel");
Lua_MapWindow = class("Lua_MapWindow", Lua_FullSizeWindow)
Lua_MapWindow.TYPE_WORLDMAP = 1;
Lua_MapWindow.TYPE_SCENEMAP = 2;

function Lua_MapWindow:ctor()
	self:superCall("ctor", true, true, 3500, true, true, false, "/images/map/ui_map_bg_01.jpg");

    self.windowName = "Lua_MapWindow";
end

function Lua_MapWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winTitleBg:setEnable(false);

	self.winTitleIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_3", "ui_common_btd_zs2", MainWinDefine.bgWidth / 2 - 1276, MainWinDefine.bgHeight / 2 - 32, 0, 0);
	self.winTitleIcon:setDepth(2);
end

function Lua_MapWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:onSelectShowType(Lua_MapWindow.TYPE_SCENEMAP);
	self:addLuaEvent("MAP_SHOW_SELECTTYPE", self, self.onSelectShowType);
end

function Lua_MapWindow:onSelectShowType(idx)
	if self.curShowIdx ~= nil and self.curShowIdx == idx then
		return;
	end

	if self.curShowIdx == Lua_MapWindow.TYPE_SCENEMAP then
		if self.sceneMapPanel ~= nil then
			self.sceneMapPanel:setEnable(false);
		end
	elseif self.curShowIdx == Lua_MapWindow.TYPE_WORLDMAP then
		if self.worldMapPanel ~= nil then
			self.worldMapPanel:setEnable(false);
		end
	end
	self.curShowIdx = idx;

	if self.curShowIdx == Lua_MapWindow.TYPE_SCENEMAP then
		if self.sceneMapPanel == nil then
			self.sceneMapPanel = Lua_SceneMapPanel.new(self.content);
			self.sceneMapPanel:setLocation(0, 0);
		else
			self.sceneMapPanel:setEnable(true);
		end
	else
		if self.worldMapPanel == nil then
			self.worldMapPanel = Lua_WorldMapPanel.new(self.content);
			self.worldMapPanel:setLocation(0, 0);
		else
			self.worldMapPanel:setEnable(true);
		end
	end
end

function Lua_MapWindow:dispose()
	if self.sceneMapPanel ~= nil then
		self.sceneMapPanel:dispose();
		self.sceneMapPanel = nil;
	end
	if self.worldMapPanel ~= nil then
		self.worldMapPanel:dispose();
		self.worldMapPanel = nil;
	end
	if self.winTitleIcon ~= nil then
		self.winTitleIcon:dispose();
		self.winTitleIcon = nil;
	end
    self:superCall("dispose");
end