-- 当前副本场景的地图显示
checkRequire("Lua_SceneMapShowPoint");
Lua_CopySceneMapPanel = class("Lua_CopySceneMapPanel", Lua_DisplayObject);
function Lua_CopySceneMapPanel:ctor(p)
    self:superCall("ctor", p, nil);

end

function Lua_CopySceneMapPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.defaultWidth = 0;
    self.defaultHeight = 0;
    -- self.safeAreaArr = Array();
    -- self.bornPointArr = Array();
    self.transferArr = Array();
    self.dynamicPointArr = Array();
    self.defaultOriginX = -193 *(MainWinDefine.bgWidth / 1280);
    self.defaultOriginY = 0;

    self:addLuaEvent("CAMPWAR_TRANSFER_UPDATE", self, self.onUpdateCampWarTransfer);
    --   self:addLuaEvent("UPDATA_CRYSTAL_PANEL", self, self.onUpdateCrystalInfo)
end

function Lua_CopySceneMapPanel:onUpdateCampWarTransfer(msg)
    local pointItem;
    local countNum = 0;
    if DataCenter.campWarData.transOpenState == 1 and DataCenter.campWarData.bInCampWarScene == true then
        -- 开启
        local arr = DataCenter.campWarUtil.campWarSceneTrans;
        if arr ~= nil then
            local len = arr:getSize();
            for i = 1, len do
                countNum = countNum + 1;
                if self.transferArr[countNum] == nil then
                    pointItem = Lua_SceneMapShowPoint.new(self.content);
                    self.transferArr:add(pointItem);
                else
                    pointItem = self.transferArr[countNum];
                end
                pointItem:setShowIcon("map_transfer_point", 43, 43, "");
                posX = self.defaultOriginX -(self.defaultWidth / 2) +(self.defaultWidth /self.mapW) * arr[i].px;
                posY = self.defaultOriginY -(self.defaultHeight / 2) +(self.defaultHeight /self.mapH) * arr[i].pz;
                pointItem:setLocation(posX, posY, 0);
            end
        end

        if DataCenter.campWarData.transOpenReturnState == 1 then
            -- 开启返回传送阵
            arr = DataCenter.campWarUtil.campWarSceneTrans_return;
            if arr ~= nil then
                len = arr:getSize();
                for i = 1, len do
                    countNum = countNum + 1;
                    if self.transferArr[countNum] == nil then
                        pointItem = Lua_SceneMapShowPoint.new(self.content);
                        self.transferArr:add(pointItem);
                    else
                        pointItem = self.transferArr[countNum];
                    end
                    pointItem:setShowIcon("map_transfer_point", 43, 43, "");
                    posX = self.defaultOriginX -(self.defaultWidth / 2) +(self.defaultWidth /self.mapW) * arr[i].px;
                    posY = self.defaultOriginY -(self.defaultHeight / 2) +(self.defaultHeight /self.mapH) * arr[i].pz;
                    pointItem:setLocation(posX, posY, 0);
                end
            end
        end
    end

    -- 去掉多余
    local num = self.transferArr:getSize() - countNum;
    while (num > 0) do
        pointItem = self.transferArr:remove(countNum + num);
        pointItem:dispose();
        pointItem = nil;
        num = num - 1;
    end
end

function Lua_CopySceneMapPanel:onUpdateCrystalInfo()
    if DataCenter.crystalWarData.buffStateList == nil or #DataCenter.crystalWarData.buffStateList == 0 then
        return
    end
    local crystalData = DataCenter.crystalWarData.buffStateList
    local tempLen = #crystalData
    local posArr = Array()
    if self.crystalObjArr == nil then
        self.crystalObjArr = Array()
    else
        for i = 1, self.crystalObjArr:getSize() do
            self.crystalObjArr[i]:dispose()
        end
        self.crystalObjArr:clear();
    end
    for i = 1, tempLen do
        if crystalData[i].camp_id ~= 0 then
            item = Lua_SceneMapShowPoint.new(self.content);
            item:setShowIcon(crystalData[i].UiName, 45, 45, crystalData[i].name)
            item:setLocation(crystalData[i].map_pos[1], crystalData[i].map_pos[2], 0);
            self.crystalObjArr:add(item)
        end
    end
end

-- 切换场景（固定点）
function Lua_CopySceneMapPanel:onSceneChange(sceneId, imgW, imgH)
    self.defaultWidth = imgW;
    self.defaultHeight = imgH;
    self.showSceneId = sceneId;
    local cData = Lua_SceneConfigData.getSceneConfig(sceneId);
    if cData.config == nil or cData.config.size == nil then
        return;
    end

    if cData.config.map_size ~= nil then
        self.mapW = cData.config.map_size[1];
        self.mapH = cData.config.map_size[2];
    else
        self.mapW = cData.config.size[1];
        self.mapH = cData.config.size[2];
    end

    if cData.config.map_win_offset ~= nil then
        self.mapWinOffsetX = cData.config.map_win_offset[1];
        self.mapWinOffsetY = cData.config.map_win_offset[2];
    else
        self.mapWinOffsetX = 0;
        self.mapWinOffsetY = 0;
    end

    self.defaultOriginX = -193 *(MainWinDefine.bgWidth / 1280) + self.mapWinOffsetX
    self.defaultOriginY = 0 + self.mapWinOffsetY;

    -- 更新安全区
    -- local arr = DataCenter.mapWindowUtil:getSceneSafeInfo(self.showSceneId);
    -- self:createPoint(arr, self.safeAreaArr);

    -- 更新出生点
    -- arr = DataCenter.mapWindowUtil:getSceneBornPointInfo(self.showSceneId);
    -- self:createPoint(arr, self.bornPointArr);

    -- 做定时更新动态点
    if self.bRegisterTimer == nil or self.bRegisterTimer == false then
        self.bRegisterTimer = true;
        Lua_CommonUtil.addTimer("updateCopySceneMapInfoTime", 1, self, self.updateCopySceneMapInfoTime, nil, -1);
    end
    self:updateCopySceneMapInfoTime();
    self:onUpdateCampWarTransfer();
    --  self:onUpdateCrystalInfo()
end

function Lua_CopySceneMapPanel:clearTimer()
    if self.bRegisterTimer ~= nil and self.bRegisterTimer == true then
        self.bRegisterTimer = false;
        Lua_CommonUtil.removeTimer(self, self.updateCopySceneMapInfoTime);
    end
end

function Lua_CopySceneMapPanel:createPoint(sourceArr, contentArr)
    if sourceArr ~= nil then
        local len = sourceArr:getSize();
        local num = len - contentArr:getSize();
        local item;
        while (num > 0) do
            item = Lua_SceneMapShowPoint.new(self.content);
            contentArr:add(item);
            num = num - 1;
        end

        while (num < 0) do
            item = contentArr:shift();
            item:dispose();
            num = num + 1;
        end

        for i = 1, len do
            item = contentArr[i];
            item:setData(sourceArr[i]);
            local posX = 0;
            local posY = 0;
            if sourceArr[i].typeName == "safe" then
                -- 安全区域要特殊处理
                if sourceArr[i].data ~= nil then
                    local list = sourceArr[i].data.rts_safe;
                    if list ~= nil and #list > 1 then
                        posX = list[1];
                        posY = list[2];
                    end
                end
            else
                -- 			print("sourceArr[i].data.posX ",sourceArr[i].data.posX ,sourceArr[i].data.posZ);
                posX = self.defaultOriginX -(self.defaultWidth / 2) +(self.defaultWidth /self.mapW ) *(sourceArr[i].data.posX);
                posY = self.defaultOriginY -(self.defaultHeight / 2) +(self.defaultHeight /self.mapH) *(sourceArr[i].data.posZ);
            end
            item:setLocation(posX, posY, 0);
        end
    end
end

-- 更新传送阵（比较特殊，如果配置在scene表，则会在Lua_SceneMapPanel显示，这里创建的传送阵是功能里动态的，scene没有配置的）
function Lua_CopySceneMapPanel:updateDynamicTransfer()

end

-- 更新动态点
function Lua_CopySceneMapPanel:updateCopySceneMapInfoTime()
    -- 掉落buff、采集物、怪物、玩家
    -- DataCenter.thingData.thingObjDic; // 暂时没用到，只存储了玩家自己信息

    local posX = 0;
    local posY = 0;
    local pointItem;
    local countNum = 0;
    local iconUrl;
    local iconW;
    local iconH;
    local txtStr;

    -- 掉落物
    local dropDic = DataCenter.thingData.dropDic;
    for k, v in pairs(dropDic) do
        local obj = getConfig( { "item", tonumber(v.item_id) });
        if obj.mapIconUrl ~= nil and obj.mapIconUrl ~= "" then
            countNum = countNum + 1;
            iconUrl = obj.mapIconUrl;
            if obj.mapIconSize ~= nil then
                iconW = obj.mapIconSize[1];
                iconH = obj.mapIconSize[2];
            else
                iconW = 26;
                iconH = 26;
            end
            if obj.mapNoShowName ~= nil and obj.mapNoShowName == 1 then
                txtStr = "";
            else
                txtStr = obj.name;
            end
            self:createDynamicPoint(countNum, v.px, v.pz, iconUrl, iconW, iconH, txtStr);
        end
    end

    -- 采集物、怪物、玩家
    local thingDic = DataCenter.thingData.thingDic;
    for k, v in pairs(thingDic) do
        if v.kind == Lua_ThingDefine.MONSTER then
            if v.monsterData ~= nil and v.monsterData.config ~= nil then
                local obj = v.monsterData.config;
                if v.isCollect == true then
                    -- 采集物\
                    if obj.mapIconUrl ~= nil and obj.mapIconUrl ~= "" then
                        countNum = countNum + 1;
                        iconUrl = obj.mapIconUrl;
                        if obj.mapIconSize ~= nil then
                            iconW = obj.mapIconSize[1];
                            iconH = obj.mapIconSize[2];
                        else
                            iconW = 26;
                            iconH = 26;
                        end
                        if obj.mapNoShowName ~= nil and obj.mapNoShowName == 1 then
                            txtStr = "";
                        else
                            txtStr = obj.name;
                        end
                        self:createDynamicPoint(countNum, v.px, v.pz, iconUrl, iconW, iconH, txtStr);
                    end
                else
                    -- 怪物
                    if obj.mapIconUrl ~= nil and obj.mapIconUrl ~= "" then
                        countNum = countNum + 1;
                        iconUrl = obj.mapIconUrl;
                        if obj.mapIconSize ~= nil then
                            iconW = obj.mapIconSize[1];
                            iconH = obj.mapIconSize[2];
                        else
                            iconW = 26;
                            iconH = 26;
                        end
                        if obj.mapNoShowName ~= nil and obj.mapNoShowName == 1 then
                            txtStr = "";
                        else
                            txtStr = obj.name;
                        end
                        self:createDynamicPoint(countNum, v.px, v.pz, iconUrl, iconW, iconH, txtStr);
                    end
                end
            end
        elseif v.kind == Lua_ThingDefine.USER then
            -- 玩家
            if v.objId ~= DataCenter.roleData.roleId then
                countNum = countNum + 1;
                local campId = v.camp_id;
                if campId == Lua_CampWarUtil.CAMPWARID_RED then
                    txtStr = "";
                    iconUrl = "map_user_point1";
                    iconW = 23;
                    iconH = 24;
                elseif campId == Lua_CampWarUtil.CAMPWARID_BLUE then
                    txtStr = "";
                    iconUrl = "map_user_point2";
                    iconW = 26;
                    iconH = 26;
                else
                    txtStr = "";
                    iconUrl = "map_user_point1";
                    iconW = 23;
                    iconH = 24;
                end
                -- buff有特殊显示的，则玩家标识用buff的
                local buffList = v.buffList;
                if buffList ~= nil then
                    local len = buffList:getSize();
                    for i = 1, len do
                        local buffVo = buffList[i];
                        if buffVo.mapIconUrl ~= nil and buffVo.mapIconUrl ~= "" then
                            iconUrl = buffVo.mapIconUrl;
                            if buffVo.mapIconSize ~= nil then
                                iconW = buffVo.mapIconSize[1];
                                iconH = buffVo.mapIconSize[2];
                            else
                                iconW = 26;
                                iconH = 26;
                            end
                            if buffVo.mapNoShowName ~= 1 then
                                txtStr = v.name;
                            end
                            break;
                        end
                    end
                end
                if DataCenter.crystalWarData.buffStateList ~= nil and #DataCenter.crystalWarData.buffStateList ~= 0 then
                    local crystalData = DataCenter.crystalWarData.buffStateList
                    local tempLen = #crystalData
                    for i = 1, tempLen do
                        if crystalData[i].id == v.objId and crystalData[i].id ~= DataCenter.roleData.roleId then
                            iconUrl = "map_fszz_stone"
                            txtStr = crystalData[i].name
                            iconW = 21
                            iconH = 40
                            break;
                        end
                    end
                end
                self:createDynamicPoint(countNum, v.px, v.pz, iconUrl, iconW, iconH, txtStr);
            end
        end
    end

    -- 去掉多余
    local num = self.dynamicPointArr:getSize() - countNum;
    while (num > 0) do
        pointItem = self.dynamicPointArr:remove(countNum + num);
        pointItem:dispose();
        pointItem = nil;
        num = num - 1;
    end
end

function Lua_CopySceneMapPanel:createDynamicPoint(idx, px, pz, iconUrl, iconW, iconH, txtStr)
    if self.dynamicPointArr[idx] == nil then
        pointItem = Lua_SceneMapShowPoint.new(self.content);
        self.dynamicPointArr:add(pointItem);
    else
        pointItem = self.dynamicPointArr[idx];
    end
    pointItem:setShowIcon(iconUrl, iconW, iconH, txtStr);
    posX = self.defaultOriginX -(self.defaultWidth / 2) +(self.defaultWidth /self.mapW) * px;
    posY = self.defaultOriginY -(self.defaultHeight / 2) +(self.defaultHeight /self.mapH) * pz;
    pointItem:setLocation(posX, posY, 0);
end

function Lua_CopySceneMapPanel:dispose()
    self:clearTimer();
    local len;
    if self.dynamicPointArr ~= nil then
        len = self.dynamicPointArr:getSize();
        for i = 1, len do
            self.dynamicPointArr[i]:dispose();
        end
        self.dynamicPointArr:clear();
        self.dynamicPointArr = nil;
    end
    if self.crystalObjArr ~= nil then
        for i = 1, self.crystalObjArr:getSize() do
            self.crystalObjArr[i]:dispose()
        end
        self.crystalObjArr:clear();
        self.crystalObjArr = nil;
    end
    -- if self.safeAreaArr ~= nil then
    -- 	len = self.safeAreaArr:getSize();
    -- 	for i = 1, len do
    -- 		self.safeAreaArr[i]:dispose();
    -- 	end
    -- 	self.safeAreaArr:clear();
    -- 	self.safeAreaArr = nil;
    -- end

    -- if self.bornPointArr ~= nil then
    -- 	len = self.bornPointArr:getSize();
    -- 	for i = 1, len do
    -- 		self.bornPointArr[i]:dispose();
    -- 	end
    -- 	self.bornPointArr:clear();
    -- 	self.bornPointArr = nil;
    -- end

    if self.transferArr ~= nil then
        len = self.transferArr:getSize();
        for i = 1, len do
            self.transferArr[i]:dispose();
        end
        self.transferArr:clear();
        self.transferArr = nil;
    end

    self:superCall("dispose");
end