-- 当前场景的地图显示
checkRequire("Lua_CopySceneMapPanel");
checkRequire("Lua_SceneMapShowPoint");
checkRequire("Lua_SceneMonsterNoticeTip");
Lua_SceneMapPanel = class("Lua_SceneMapPanel", Lua_DisplayObject);
function Lua_SceneMapPanel:ctor(p)
    self:superCall("ctor", p, "SceneMapPanel_skin");
end

function Lua_SceneMapPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.isHunDun = false;

    self.vRate = MainWinDefine.bgHeight / 720; -- 垂直
    self.hRate = MainWinDefine.bgWidth / 1280; -- 水平

    self.defaultWidth = 780;
	self.defaultHeight = 780;
	self.defaultOriginX = -193 * (MainWinDefine.bgWidth / 1280);
	self.defaultOriginY = 0;
	
	self.mapBgOffsetX = 0;
	self.mapBgOffsetY = 0;

	self.nameTxt = UICreate.createLabel(self.content, "", - MainWinDefine.bgWidth / 2 + 111, MainWinDefine.bgHeight / 2 - 31, 100, 50, 34);
	self.nameTxt:setDepth(3);
	self.nameTxt.pivot = UIWidget.Pivot.Left;
	self.nameTxt.overflowMethod = UILabel.Overflow.ResizeFreely;

	self.worldBtn.clickScale = false;
	self.worldBtn:addClickFuntion(self, self.onSceneBtnClick);

	self.ownPointNeedRotation = true;
	self.ownPoint = Lua_SceneMapShowPoint.new(self.content);
	self.ownPoint:setShowIcon("ui_map_icon_me2", 65, 54, "");
	self.ownPoint:setDepth(7);

	self.flyIcon = UICreate.createUIAtlasImage(self.content,  "mainWindow_atlas", "ui_zhujiemian_icon_21", self.defaultOriginX, self.defaultOriginY, 0, 0);
	self.flyIcon:setDepth(8);
	self.flyIcon.clickScale = false;
	self.flyIcon:addClickFuntion(self, self.onFlyIconClick);
	self.flyIcon:setEnable(false);

	local arr = Array();
	arr:add(LanUtil.getValue(123301));
	arr:add(LanUtil.getValue(123302));
	arr:add(LanUtil.getValue(123303));
	self.btnList = Lua_ButtonList.new(self.content, arr, 113, self, self.onTypeBtnClick,
		"ui_common_btn_9", "ui_common_btn_8", Vector4(0, 0, 99, 32), Vector4(0, 0, 99, 32),
		Lua_ColorDefine.transColor("B7E3FF"), Lua_ColorDefine.transColor("FFFCB7"), Vector4(20, 20, 120, 30),
		2, "common_atlas_1", Vector3(0, 0, 0), Vector3(0, 0, 0));
	self.btnList:setDepth(3);
	self.btnList:setLocation(MainWinDefine.bgWidth / 2 - 295, -MainWinDefine.bgHeight / 2 + 50, 0);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 308, 600));
    self.dragList:setLocation(MainWinDefine.bgWidth / 2 - 180, 35, 0);
    self.dragList:setListCell(Lua_SceneMapItem, 70, 307, 1);

    self.pointArr = Array();
    self.transferArr = Array();
    self.teleportArr = Array();
    self.npcArr = Array();
    self.monsterArr = Array();
    self.safeAreaArr = Array();
	self.bornPointArr = Array();
    self.layerDataDic = {};

	self:setShowCurScene();
	self:addLuaEvent("SCENE_CHANGE", self, self.onSceneChange);
	self:addLuaEvent("SCENEMAPITEM_SELECTED", self, self.onSelectListItem);
	self:addLuaEvent("SCENEMAP_CANCLE_CLICKFLY", self, self.onCancleFlyShow);
	self:addLuaEvent("PLAYER_POS_UPDATE", self, self.onUpdatePlayerPos);
	self:addLuaEvent("ROLE_BUFF_UPDATE", self, self.onUpdatePlayerBuff);
	self:addCSharpEvent("CheckJump", self, self.onUpdatePlayerPos);
	self:addCSharpEvent("MoveCompleteCallBack", self, self.onMoveComplete);
    self:setShowHunDun();
end

function Lua_SceneMapPanel:onUpdatePlayerBuff()
	local iconUrl;
	local iconStr;
	local imgW;
	local imhH;

	self.ownPointNeedRotation = true;
	local campId = DataCenter.roleData.camp_id;
	if campId == Lua_CampWarUtil.CAMPWARID_RED then
		iconUrl = "ui_map_icon_me2";
		iconStr = "";
		imgW = 62;
		imhH = 51;
    elseif campId == Lua_CampWarUtil.CAMPWARID_BLUE then
    	iconUrl = "ui_map_icon_me";
		iconStr = "";
		imgW = 62;
		imhH = 51;
    else
    	iconUrl = "ui_map_icon_me";
		iconStr = "";
		imgW = 62;
		imhH = 51;
    end

	-- buff有特殊显示的，则玩家标识用buff的
    local buffList = DataCenter.roleData.buffList
    if buffList ~= nil then
    	local len = buffList:getSize();
    	for i = 1, len do
    		local buffVo = buffList[i];
    		if buffVo.mapIconUrl ~= nil and buffVo.mapIconUrl ~= "" then
    			iconUrl = buffVo.mapIconUrl;
    			if buffVo.mapIconSize ~= nil then
					imgW = buffVo.mapIconSize[1];
					imhH = buffVo.mapIconSize[2];
				else
					imgW = 50;
					imhH = 37;
				end

				if buffVo.mapNoShowName ~= 1 then
					iconStr = DataCenter.roleData.name;
				end
				self.ownPointNeedRotation = false;
    			break;
    		end
    	end
    end

    -- self.ownPoint:setAltas("mapWindow", "map_self_point");
    -- self.ownPoint:SetDimensions(62, 51);
    self.ownPoint:setShowIcon(iconUrl, imgW, imhH, iconStr);
end

function Lua_SceneMapPanel:cleanMoveEvent()
	if self.transEventKey ~= nil then
		MsgUtil.removeEventListener("MoveCompleteCallBack",self.transEventKey);
		self.transEventKey = nil;
	end
end

function Lua_SceneMapPanel:onFlyIconClick(go)
	if self.flyVec ~= nil then
		local roleId = tonumber(DataCenter.roleData.roleId);
		local ac = WorldMapUtil.genArriveActionVo({type = 10, targetId = Lua_CommonUtil.trnsLongNum(roleId)});
		local num = DataCenter.roleData:tranceTo(DataCenter.roleData.sceneId, self.flyVec.x, self.flyVec.y, self.flyVec.z, 0, 0, ac, 0);
		-- if num == 1 then -- 传送
		-- 	self:onMoveComplete(DataCenter.roleData.roleId);
		-- end
		self:cleanMoveEvent();
		if num == 2 then
			self.transEventKey = MsgUtil.addEventListener("MoveCompleteCallBack", self, self.moveCompleteCallBack);		
		elseif num == 1 then
			self:onMoveComplete(DataCenter.roleData.roleId);
			self:moveCompleteCallBack();
		end
	end
end

--寻路完毕
function Lua_SceneMapPanel:moveCompleteCallBack()
	self:cleanMoveEvent();
	self:updateRoleOperation();
	Lua_WindowUtil.openWin("Lua_MapWindow", WinParam.ACTION_CLOSE, nil);
end

function Lua_SceneMapPanel:onSceneLoaded()
	self:updateRoleOperation(1);
	Lua_WindowUtil.openWin("Lua_MapWindow", WinParam.ACTION_CLOSE, nil);
end

function Lua_SceneMapPanel:updateRoleOperation(transferType)
	if self.selectListItemData ~= nil then
		if self.selectListItemData.typeName == "monster" then -- 挂机
			DataCenter.hook:start();
			self.selectListItemData = nil;
		elseif self.selectListItemData.typeName == "npc" then -- 对话
			local data = self.selectListItemData.data;
			if data ~= nil then
				DataCenter.hook:stop(true);
				WorldMapUtil.moveTo(DataCenter.roleData.sceneId, data.posX, data.posY, data.posZ, data.id, 7, nil, 0);
			end
			self.selectListItemData = nil;
		elseif self.selectListItemData.typeName == "exits" or self.selectListItemData.typeName == "teleport" then -- 传送
			if transferType ~= nil and transferType == 1 then
				Lua_CommonUtil.addTimer("mapwin_transferScene", 1, self, self.transferScene, nil, 1);
			end
		end
	end
end

function Lua_SceneMapPanel:transferScene()
	if self.selectListItemData ~= nil and (self.selectListItemData.typeName == "exits" or self.selectListItemData.typeName == "teleport") then
		local data = self.selectListItemData.data;
		local cData = Lua_SceneConfigData.getSceneConfig(data.id);
		if cData == nil or DataCenter.roleData.level < cData.minLv then 
			self.selectListItemData = nil;
			return;
		end
		Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(data.id, data.targetPosX, data.targetPosY, data.targetPosZ, 0);
		self.selectListItemData = nil;
	end
end

function Lua_SceneMapPanel:onMoveComplete(roleId)
	if tostring(DataCenter.roleData.roleId) == tostring(roleId) then
		self.flyVec = nil;
		self.flyIcon:setEnable(false);
		self:clearWalkPath();
	end
end

function Lua_SceneMapPanel:onCancleFlyShow(obj)
	self.flyVec = nil;
	self.flyIcon:setEnable(false);
	self:cleanMoveEvent();
	if obj ~= nil then
		self:showWalkPath(obj.x, obj.y, obj.z);
		self.transEventKey = MsgUtil.addEventListener("MoveCompleteCallBack", self, self.moveCompleteCallBack);	
	else -- 传送
		self:clearWalkPath();
		--self:onSceneLoaded();
		Lua_WindowUtil.openWin("Lua_MapWindow", WinParam.ACTION_CLOSE, nil);
	end
end

function Lua_SceneMapPanel:onSceneImgClick(go)
	local curTime = getTime();
	if self.lastClickTime ~= nil and curTime - self.lastClickTime < 0.2 then
		return;
	end
	self.lastClickTime = curTime;

	local v = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.content.transform:InverseTransformPoint(screenpos);
	local posX = (mousePosition.x - self.defaultOriginX + (self.defaultWidth / 2)) / (self.defaultWidth / self.mapW) ;
	local posZ = (mousePosition.y - self.defaultOriginY + (self.defaultHeight / 2)) / (self.defaultHeight / self.mapH) ;
	local vec = WorldMapUtil.getYByXZ(posX, posZ);
	if vec == nil or (vec.x == -100000 and vec.y == -100000 and vec.z == -100000) then
		self.flyVec = nil;
		-- OperateAlert.show(LanUtil.getValue(123305));
		return;
	else
		DataCenter.hook:stop(true);
		self.flyVec = vec;
		local cData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	    if cData.config ~= nil and cData.config.unableTransfer == 1 then
	    	self.flyIcon:setEnable(false);
	    else
	    	self.flyIcon:setEnable(true);
			self.flyIcon:setLocation(mousePosition.x, mousePosition.y);
	    end
		local roleId = tonumber(DataCenter.roleData.roleId);
		local ac = WorldMapUtil.genArriveActionVo({type = 10, targetId = Lua_CommonUtil.trnsLongNum(roleId)});
		WorldMapUtil.moveTo(DataCenter.roleData.sceneId, vec.x, vec.y, vec.z, 0, 0, ac, 0);
		self:showWalkPath(vec.x, vec.y, vec.z);
		
		-- 到达终点自动挂机并关闭界面
		self:cleanMoveEvent();
		self.selectListItemData = nil;
		self.transEventKey = MsgUtil.addEventListener("MoveCompleteCallBack", self, self.moveCompleteCallBack);	
	end
end
 
function Lua_SceneMapPanel:onSceneBtnClick(go)
	self:cleanMoveEvent();
	self.selectListItemData = nil;
	Lua_MsgUtil.callFunc("MAP_SHOW_SELECTTYPE", Lua_MapWindow.TYPE_WORLDMAP);
end

function Lua_SceneMapPanel:onTypeBtnClick(val, bb)
	self:selectShowType(val);
end

-- 切换场景
function Lua_SceneMapPanel:onSceneChange(o)
	if self.sceneImg ~= nil then
		self.sceneImg:dispose();
		self.sceneImg = nil;
	end
	
	self.flyVec = nil;
	self.flyIcon:setEnable(false);
	self:clearWalkPath();
	self:setShowCurScene();
end

-- 更新玩家位置
function Lua_SceneMapPanel:onUpdatePlayerPos()
	local rd = DataCenter.roleData;
	local posX = self.defaultOriginX - (self.defaultWidth / 2) + (self.defaultWidth / self.mapW) * (rd.px );
	local posY = self.defaultOriginY - (self.defaultHeight / 2) + (self.defaultHeight / self.mapH) * (rd.pz);
	self.ownPoint:setLocation(posX, posY, 0);
	if self.ownPointNeedRotation == true then
		-- self.ownPoint.mainContent.transform.localRotation = Quaternion.Euler(0, 0, rd.dir - 90);
		LuaUtil.setObjRot(self.ownPoint.mainContent, 0, 0, rd.dir - 90);
	end
end

-- 显示路径
function Lua_SceneMapPanel:showWalkPath(tx, ty, tz)
	self:clearWalkPath();
	local rd = DataCenter.roleData;
	local list = WorldMapUtil.genPath(rd.px, rd.py, rd.pz, tx, ty, tz);
	if list ~= nil then
		local len = list.Count;
		for i = 1, len do
			local vec = list[i - 1];
			local posX = self.defaultOriginX - (self.defaultWidth / 2) + (self.defaultWidth / self.mapW) * (vec.x );
			local posY = self.defaultOriginY - (self.defaultHeight / 2) + (self.defaultHeight / self.mapH) * (vec.z );
			local point = UICreate.createUIAtlasImage(self.content,  "map_atlas", "ui_map_widget_01", posX, posY, 0, 0);
			point:setDepth(6);
			self.pointArr:add(point);

			if i > 1 then
                local dis = Vector3.Distance(list[i - 2], vec);
                local num = math.floor(dis / 300);
                if num > 1 then
					dis = dis / num;
                    local dir = vec - list[i - 2];
                    dir:SetNormalize();
                    for j = 1, num - 1 do
						local cur = list[i - 2] + dir * dis * j;
                        posX = self.defaultOriginX - (self.defaultWidth / 2) + (self.defaultWidth / self.mapW) * (cur.x );
						posY = self.defaultOriginY - (self.defaultHeight / 2) + (self.defaultHeight / self.mapH) * (cur.z );
						point = UICreate.createUIAtlasImage(self.content,  "map_atlas", "ui_map_widget_01", posX, posY, 0, 0);
						point:setDepth(6);
						self.pointArr:add(point);
                    end
                end
            end
		end
	end
end

function Lua_SceneMapPanel:clearWalkPath()
	if self.pointArr ~= nil then
		local len = self.pointArr:getSize();
		for i = 1, len do
			self.pointArr[i]:dispose();
		end
		self.pointArr:clear();
	end
end

-- 显示地图
function Lua_SceneMapPanel:setShowCurScene()

	local sceneId = DataCenter.roleData.sceneId;
	if self.showSceneId == sceneId then
		return;
	end
	local cData = Lua_SceneConfigData.getSceneConfig(sceneId);
	if  cData.config == nil or cData.config.size == nil then 
		return;
	end

	if cData.config.map_size ~= nil then
		self.mapW = cData.config.map_size[1];
		self.mapH = cData.config.map_size[2];
	else
		self.mapW = cData.config.size[1];
		self.mapH = cData.config.size[2];
	end
	
	if cData.config.map_win_offset ~= nil then
		self.mapWinOffsetX = cData.config.map_win_offset[1];
		self.mapWinOffsetY = cData.config.map_win_offset[2];
	else
		self.mapWinOffsetX = 0;
		self.mapWinOffsetY = 0;
	end 
	
	if cData.config.map_bg_offset ~= nil then
		self.mapBgOffsetX = cData.config.map_bg_offset[1];
		self.mapBgOffsetY = cData.config.map_bg_offset[2];
	else
		self.mapBgOffsetX =0;
		self.mapBgOffsetY =0;
	end

	self.defaultOriginX = -193 * (MainWinDefine.bgWidth / 1280) + self.mapWinOffsetX
	self.defaultOriginY = 0 + self.mapWinOffsetY;

	self.showSceneId = sceneId;
	self.bChange = true;
	if self.showIdx ~= nil then
		self.btnList:setSelected(self.showIdx, true);
	else
		if DataCenter.mapWindowUtil:getSceneMonsterInfo(self.showSceneId):getSize() > 0 then
			self.btnList:setSelected(Lua_MapWindowUtil.MONSTER, true);
		elseif DataCenter.mapWindowUtil:getSceneNPCInfo(self.showSceneId):getSize() > 0 then
			self.btnList:setSelected(Lua_MapWindowUtil.NPC, true);
		elseif DataCenter.mapWindowUtil:getSceneTransInfo(self.showSceneId):getSize() > 0 then
			-- or DataCenter.mapWindowUtil:getSceneTeleportInfo(self.showSceneId):getSize() > 0 then
			self.btnList:setSelected(Lua_MapWindowUtil.TRANSFER, true);
		else
			self.btnList:setSelected(Lua_MapWindowUtil.NPC, true);
		end
	end
	-- 全场景广播
    if cData.config.single_map ~= nil and cData.config.single_map == 1 then
        if self.copySceneMapPanel == nil then
        	self.copySceneMapPanel = Lua_CopySceneMapPanel.new(self.content);
        	self.copySceneMapPanel:setDepth(2);
			self.copySceneMapPanel:setLocation(0,0,0);
--        	self.copySceneMapPanel:setLocation(self.defaultOriginX + self.mapWinOffsetX, self.defaultOriginY + self.mapWinOffsetY, 0);
        end
   	else
   		if self.copySceneMapPanel ~= nil then
   			self.copySceneMapPanel:dispose();
   			self.copySceneMapPanel = nil;
   		end
    end

	if self.sceneImg == nil then
		self.sceneImg = UICreate.createImage(self.content, "", self.defaultOriginX, self.defaultOriginY, 0, 0);
	    self.sceneImg:setDepth(1);
	    self.sceneImg.clickScale = false;
	    self.sceneImg:addLoadCompleteFun(self, self.onLoadCompleteSceneImg);
	    self.sceneImg:addClickFuntion(self, self.onSceneImgClick);
   	end
   	-- self.sceneImg:setLocation(self.defaultOriginX + self.mapWinOffsetX, self.defaultOriginY + self.mapWinOffsetY);
   	self.sceneImg:setLocation(self.defaultOriginX+self.mapBgOffsetX, self.defaultOriginY+self.mapBgOffsetY);
	self.sceneImg:setUrl("/maps/"..cData.config.res_min);

	local bgSize = cData.config.map_bg_size;
	if bgSize ~= nil then
		self.sceneImg:setScale(bgSize[1], bgSize[2]);
	else
		self.sceneImg:setScale(1, 1);
	end
	
	self.nameTxt.text = getConfig({"scene", sceneId, "name"});
end

function Lua_SceneMapPanel:onLoadCompleteSceneImg(go)
	self.defaultWidth = self.sceneImg.width;
	self.defaultHeight = self.sceneImg.height;

	-- local campId = DataCenter.roleData.camp_id;
	-- if campId == Lua_CampWarUtil.CAMPWARID_RED then
 --        self.ownPoint:setAltas("mapWindow", "map_self_point");
	--     self.ownPoint:SetDimensions(62, 51);
 --    elseif campId == Lua_CampWarUtil.CAMPWARID_BLUE then
 --        self.ownPoint:setAltas("mapWindow", "map_self_point2");
	--     self.ownPoint:SetDimensions(62, 51);
 --    else
 --    	self.ownPoint:setAltas("mapWindow", "map_self_point2");
	--     self.ownPoint:SetDimensions(62, 51);
 --    end

 	self:onUpdatePlayerBuff();
	self:setShowTransfer();
	-- self:setShowTeleport();
	self:setShowNPC();
	self:setShowMonster();
	self:setShowSafeArea();
	self:setShowBornPoint();
	self:onUpdatePlayerPos();
	if self.showMonsterTipVo ~= nil then
		self:showMonsterNoticeTip(self.showMonsterTipVo);
	end

	if self.copySceneMapPanel ~= nil then
		self.copySceneMapPanel:onSceneChange(self.showSceneId, self.defaultWidth, self.defaultHeight);
	end
end

-- 显示列表
function Lua_SceneMapPanel:selectShowType(idx)
	if self.bChange == false and self.showIdx ~= nil and self.showIdx == tonumber(idx) then
		return;
	end
	self.showIdx = tonumber(idx);

	local arr;
	if idx == Lua_MapWindowUtil.TRANSFER then
		arr = Array();
		local exitArr =  DataCenter.mapWindowUtil:getSceneTransInfo(self.showSceneId);
		if exitArr:getSize() > 0 then
			for i = 1, exitArr:getSize() do
				arr:add(exitArr[i]);
			end
		end

		-- local exitArr =  DataCenter.mapWindowUtil:getSceneTeleportInfo(self.showSceneId);
		-- if exitArr:getSize() > 0 then
		-- 	for i = 1, exitArr:getSize() do
		-- 		arr:add(exitArr[i]);
		-- 	end
		-- end
	elseif idx == Lua_MapWindowUtil.NPC then
		arr = DataCenter.mapWindowUtil:getSceneNPCInfo(self.showSceneId);
	else
		arr = DataCenter.mapWindowUtil:getSceneMonsterInfo(self.showSceneId);
	end

	-- 如果是怪物，则进行推荐
	local showVo;
	if idx == Lua_MapWindowUtil.MONSTER then
		local minAttack = 999999999;
		local maxAttack = -1;

		-- 0、人物大于怪物攻击力
		-- 1、怪物攻击比人物防御低 
		-- 2、等级最高（更改为 -- 取相邻等级怪，列如 人物等级405，取400级怪，人物等级406，取410级怪）
		-- 3、等级一样则选择要求防御高的
		local maxResult = 0;
		local maxVo = nil;
		local minResult = 0;
		local minVo = nil;
		local own_vo = nil;
		local len = arr:getSize();
		local ownDefine = DataCenter.roleData.defence;
		local ownLevel = DataCenter.roleData.level;

		for i = 1, len do
			if arr[i].data ~= nil then
				local objId = arr[i].data.id;
				if objId ~= nil then
					local vo = DataCenter.mapWindowUtil:getMonsterNoticeVo(objId);
					if vo ~= nil then
						if vo.monsterAttack <= ownDefine then
							if own_vo == nil or own_vo.monsterLv < vo.monsterLv then
								own_vo = vo;
								if arr[i+1] ~= nil then
									local tvo = DataCenter.mapWindowUtil:getMonsterNoticeVo(arr[i+1].data.id);
									if tvo ~= nil then		
										if vo.monsterLv < tvo.monsterLv then
											if tvo.monsterLv - vo.monsterLv == 5 then
												if  ownLevel > vo.monsterLv + 2 and ownLevel < tvo.monsterLv then
													maxVo = tvo;
													maxResult = i+1;
												elseif ownLevel > vo.monsterLv and ownLevel < tvo.monsterLv - 2 then
													maxVo = vo;
													maxResult = i;
												elseif ownLevel == vo.monsterLv then
													maxVo = vo;
													maxResult = i;
												elseif ownLevel >= tvo.monsterLv then
													maxVo = tvo;
													maxResult = i+1;
												end
											else
												if  ownLevel > vo.monsterLv + 5 and ownLevel < tvo.monsterLv then
													maxVo = tvo;
													maxResult = i+1;
												elseif ownLevel > vo.monsterLv and ownLevel < tvo.monsterLv - 4 then
													maxVo = vo;
													maxResult = i;
												elseif ownLevel == vo.monsterLv then
													maxVo = vo;
													maxResult = i;
											elseif ownLevel > vo.monsterLv then--and ownLevel < tvo.monsterLv then
											maxVo = vo;
											maxResult = i;
										end
									end
								end
							end
						end
							elseif own_vo.monsterLv == vo.monsterLv and ownLevel >= vo.monsterLv then							
								if own_vo.defence < vo.defence then	
									maxVo = vo;
									maxResult = i;
								end
							end
						elseif vo.monsterAttack > ownDefine and maxResult == 0 then
							if minVo == nil or minVo.monsterLv > vo.monsterLv then
								minVo = vo;
								minResult = i;
							end
						end
					end
				end
			end
		end


		if maxResult > 0 then
			DataCenter.mapWindowUtil.sceneSelectId = tonumber(arr[maxResult].data.id);
			showVo = arr[maxResult].data;
		elseif minResult > 0 then
			DataCenter.mapWindowUtil.sceneSelectId = tonumber(arr[minResult].data.id);
			showVo = arr[minResult].data;
		elseif len > 0 then
			DataCenter.mapWindowUtil.sceneSelectId = tonumber(arr[1].data.id);
			showVo = arr[1].data;
		end
	else
		if arr:getSize() > 0 then
			DataCenter.mapWindowUtil.sceneSelectId = tonumber(arr[1].data.id);
		end
	end

	self:showMonsterNoticeTip(showVo);
	self.dragList:setLuaArrayData(arr, false);
end

function Lua_SceneMapPanel:onSelectListItem(obj)
	self.selectListItemData = obj;
	local showVo = obj.data;
	DataCenter.mapWindowUtil.sceneSelectId = showVo.id;
	local arr = self.dragList.showList;
	local len = arr:getSize();
	for i = 1, len do 
		arr[i]:updateSelect();
	end

	if self.showIdx == Lua_MapWindowUtil.MONSTER then
		self:showMonsterNoticeTip(showVo);
	else
		self:showMonsterNoticeTip(nil);
	end
end
-- 显示传送阵
function Lua_SceneMapPanel:setShowTransfer()
	local arr = DataCenter.mapWindowUtil:getSceneTransInfo(self.showSceneId);
	self:createPoint(arr, self.transferArr);
end

-- 显示瞬移点
function Lua_SceneMapPanel:setShowTeleport()
	local arr = DataCenter.mapWindowUtil:getSceneTeleportInfo(self.showSceneId);
	self:createPoint(arr, self.teleportArr);
end

-- 显示npc
function Lua_SceneMapPanel:setShowNPC()
	local arr = DataCenter.mapWindowUtil:getSceneNPCInfo(self.showSceneId);
	self:createPoint(arr, self.npcArr);
end

-- 显示怪物
function Lua_SceneMapPanel:setShowMonster()
	local arr = DataCenter.mapWindowUtil:getSceneMonsterInfo(self.showSceneId);
	self:createPoint(arr, self.monsterArr);
end
function Lua_SceneMapPanel:setShowHunDun()
    if Lua_WindowUtil.isWindowShowing("Lua_ChaoticLeftInfoWindow") == false then
        return;
    end
    local listData=DataCenter.bossData:getBossDetailByType(Lua_BossData.TYPE_CHAOTIC_KUAFU);
    if listData~=nil and listData.bossDetailSet~=nil then
        for k,v in ipairs(listData.bossDetailSet) do
            if self.layerDataDic[tostring(v.layer)] == nil then
                self.layerDataDic[tostring(v.layer)] = Array();
            end
            local tarr = self.layerDataDic[tostring(v.layer)];
            tarr:add(v);
        end
        local tlist = self.layerDataDic[tostring(tonumber(DataCenter.roleData.sceneId)%71800)]
        if tlist~=nil then
            for i = 1, tlist:getSize() do
                for j=1,self.monsterArr:getSize() do
                    self.monsterArr[j]:setShowHunDun(tlist[i].monster_id,tlist[i].gather_id);
                end
            end
        end
    end
end

-- 更新安全区
function Lua_SceneMapPanel:setShowSafeArea()
	local arr = DataCenter.mapWindowUtil:getSceneSafeInfo(self.showSceneId);
	self:createPoint(arr, self.safeAreaArr);
end

-- 更新出生点
function Lua_SceneMapPanel:setShowBornPoint()
	arr = DataCenter.mapWindowUtil:getSceneBornPointInfo(self.showSceneId);
	self:createPoint(arr, self.bornPointArr);
end

function Lua_SceneMapPanel:createPoint(sourceArr, contentArr)
	if sourceArr ~= nil then
		local len = sourceArr:getSize();
		local num = len - contentArr:getSize();
		local item;
		while (num > 0) do
			item = Lua_SceneMapShowPoint.new(self.content);
			contentArr:add(item);
			num = num - 1;
		end

		while (num < 0) do
			item = contentArr:shift();
			item:dispose();
			num = num + 1;
		end

		for i = 1, len do 
			item = contentArr[i];
			item:setData(sourceArr[i]);
			local posX = 0;
			local posY = 0;
			if sourceArr[i].typeName == "safe" then-- 安全区域要特殊处理
				if sourceArr[i].data ~= nil then
					local list = sourceArr[i].data.rts_safe;
					if list ~= nil and #list > 1 then
						posX = list[1];
						posY = list[2];
					end
				end
			else
				posX = self.defaultOriginX - (self.defaultWidth / 2) + (self.defaultWidth / self.mapW) * (sourceArr[i].data.posX );
				posY = self.defaultOriginY - (self.defaultHeight / 2) + (self.defaultHeight / self.mapH) * (sourceArr[i].data.posZ );
			end
			item:setLocation(posX, posY, 0);
		end
	end
end

-- 显示怪物信息
function Lua_SceneMapPanel:showMonsterNoticeTip(showVo)
	local noticeVo;
	self.showMonsterTipVo = showVo;
	if showVo ~= nil then
		noticeVo = DataCenter.mapWindowUtil:getMonsterNoticeVo(showVo.id);
	end

	if noticeVo ~= nil then
		if self.monsterTip == nil then
			self.monsterTip = Lua_SceneMonsterNoticeTip.new(self.content);
			self.monsterTip:setDepth(20);
		end
		self.monsterTip:setEnable(true);
		self.monsterTip:setData(noticeVo);
		-- 计算位置
		local tipW = self.monsterTip:getWidth();
		local tipH = self.monsterTip:getHeight();
		local posX = self.defaultOriginX - (self.defaultWidth / 2) + (self.defaultWidth / self.mapW) * (showVo.posX);
		local posY = self.defaultOriginY - (self.defaultHeight / 2) + (self.defaultHeight / self.mapH) * (showVo.posZ);
		local centerX = -193; -- 宽840
		local centerY = 0; -- 高640
		local tx;
		local ty;
		local isLeft = false;
		
		if posX > centerX then -- 显示左侧
			tx = posX - tipW - 8;
		else -- 显示右侧
			isLeft = true;
			tx = posX + 8;
		end
		if tx + tipW > centerX + 420 then
			tx = centerX + 420 - tipW;
		end
		if tx < centerX - 420 then
			tx = centerX - 420;
		end

		local isDown = false;
		if posY > centerY then -- 显示下侧
			ty = posY - 8;
		else -- 显示上侧
			isDown = true;
			ty = posY + tipH + 8;
		end
		if ty > centerY + 320 then
			ty = centerY + 320;
		end
		if ty - tipH < centerY - 320 then
			ty = centerY - 320 + tipH;
		end
		self.monsterTip:setLocation(tx, ty, 0);
		self.monsterTip:setArrowType(isLeft, isDown);
	else
		if self.monsterTip ~= nil then
			self.monsterTip:setEnable(false);
		end
	end
end

function Lua_SceneMapPanel:dispose()
	local len;
	if self.transferArr ~= nil then
		len = self.transferArr:getSize();
		for i = 1, len do 
			self.transferArr[i]:dispose();
		end
		self.transferArr:clear();
		self.transferArr = nil;
	end

    if self.npcArr ~= nil then
		len = self.npcArr:getSize();
		for i = 1, len do 
			self.npcArr[i]:dispose();
		end
		self.npcArr:clear();
		self.npcArr = nil;
	end

    if self.monsterArr ~= nil then
		len = self.monsterArr:getSize();
		for i = 1, len do 
			self.monsterArr[i]:dispose();
		end
		self.monsterArr:clear();
		self.monsterArr = nil;
	end

	if self.safeAreaArr ~= nil then
		len = self.safeAreaArr:getSize();
		for i = 1, len do 
			self.safeAreaArr[i]:dispose();
		end
		self.safeAreaArr:clear();
		self.safeAreaArr = nil;
	end

	if self.bornPointArr ~= nil then
		len = self.bornPointArr:getSize();
		for i = 1, len do 
			self.bornPointArr[i]:dispose();
		end
		self.bornPointArr:clear();
		self.bornPointArr = nil;
	end

	if self.copySceneMapPanel ~= nil then
		self.copySceneMapPanel:dispose();
		self.copySceneMapPanel = nil;
	end

	self:clearWalkPath();
	self.pointArr = nil;
	self.flyVec = nil;

    self:superCall("dispose");
end















Lua_SceneMapItem = class("Lua_SceneMapItem", Lua_ListCell);
function Lua_SceneMapItem:ctor(p)
    self:superCall("ctor", p, "SceneMapItem_skin");

end

function Lua_SceneMapItem:buildShowItem()
    self:superCall("buildShowItem");

    self.normalBg:setEnable(true);
	self.selectedBg:setEnable(false);
    self.txt.text = "";
    self.fly:addClickFuntion(self, self.onFlyClick);
    self.canFly = false;
end

function Lua_SceneMapItem:onFlyClick(go)
	if self.data ~= nil then
		-- self:onPlayerSoundClick(nil);
		DataCenter.hook:start();
		Lua_MsgUtil.callFunc("SCENEMAPITEM_SELECTED", {data = self.data, typeName = self.typeName});
		local roleId = tonumber(DataCenter.roleData.roleId);
		local ac = WorldMapUtil.genArriveActionVo({type = 10, targetId = Lua_CommonUtil.trnsLongNum(roleId)});
		local num = DataCenter.roleData:tranceTo(DataCenter.roleData.sceneId, self.data.posX, self.data.posY, self.data.posZ, 0, 0, ac, 0);
		if num > 0 then
			local obj = nil;
			if num > 1 then
				obj = {x = self.data.posX, y = self.data.posY, z =self.data.posZ};
			end
			Lua_MsgUtil.callFunc("SCENEMAP_CANCLE_CLICKFLY", obj);
		end
	end
end

function Lua_SceneMapItem:setData(data)
	if data.data.isConceal == 1 then
		self.itemObj:SetActive(false);
		return
	end
	self.itemObj:SetActive(true);
	self.typeName = data.typeName;
    self.data = data.data;
    self.desc = "";
    self.bSelected = nil;
    if data ~= nil then
    	self.bossSpr:setEnable(false);
    	if self.typeName == "exits" or self.typeName == "teleport" then
			self.desc = (self.data.name == nil) and "" or self.data.name;
		elseif self.typeName == "npc" then
			local obj = getConfig({"monster", self.data.id});
	    	if obj ~= nil then -- npc
	    		self.desc = obj.name;
	    	end
		elseif self.typeName == "monster" then
			local obj = getConfig({"monster", self.data.id});
	    	if obj ~= nil then -- 怪物
	    		self.desc = "Lv."..obj.lvl.." "..obj.name;
	    	end
	    	if self.data.showBossicon == 1 and self.data.showBossicon ~= nil then
	    		self.bossSpr:setEnable(true);
	    	else
	    		self.bossSpr:setEnable(false);
	    	end
		end
    	self:updateSelect();
    	self.fly:setLocation(self.txt.width / 2 + 8, 0);
    end

    local cData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if cData.config ~= nil and cData.config.unableTransfer == 1 then
    	self.fly:setEnable(false);
    	self.canFly = false;
    else
    	self.fly:setEnable(true);
    	self.canFly = true;
    end
end

function Lua_SceneMapItem:updateSelect()
	if DataCenter.mapWindowUtil.sceneSelectId == tonumber(self.data.id) then
    	self:setSelected(true);
    else
    	self:setSelected(false);
    end
end

function Lua_SceneMapItem:setSelected(val)
	if self.bSelected == val then
		return;
	end
	self.bSelected = val;

	if val == true then
		self.normalBg:setEnable(false);
		self.selectedBg:setEnable(true);
		-- self.txt.text = Lua_ColorDefine.colorStr(self.desc, "742c00");
	else
		self.normalBg:setEnable(true);
		self.selectedBg:setEnable(false);
		-- self.txt.text = Lua_ColorDefine.colorStr(self.desc, "192e41");
	end
	self.txt.text = self.desc;
end

function Lua_SceneMapItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		if (self.data.isFindPath ~= nil and self.data.isFindPath == 1) or self.typeName == "teleport" then 
			DataCenter.hook:stop(true);
			local roleId = tonumber(DataCenter.roleData.roleId);
			local ac = WorldMapUtil.genArriveActionVo({type = 10, targetId = Lua_CommonUtil.trnsLongNum(roleId)});
			WorldMapUtil.moveTo(DataCenter.roleData.sceneId, self.data.posX, self.data.posY, self.data.posZ, 0, 0, ac, 0);
			Lua_MsgUtil.callFunc("SCENEMAP_CANCLE_CLICKFLY", {x = self.data.posX, y = self.data.posY, z =self.data.posZ});
		end
		Lua_MsgUtil.callFunc("SCENEMAPITEM_SELECTED", {data = self.data, typeName = self.typeName});
	end
end

function Lua_SceneMapItem:dispose()
    self:superCall("dispose");
end