-- 传送阵、npc、怪物
Lua_SceneMapShowPoint = class("Lua_SceneMapShowPoint", Lua_DisplayObject)
function Lua_SceneMapShowPoint:ctor(p)
	self:superCall("ctor", p, "SceneMapShowPoint_skin");
end

function Lua_SceneMapShowPoint:buildShowItem()
	self:superCall("buildShowItem");

	self.img = UICreate.createImage(self.content, "", 0, 0, 0, 0);
	self.img:setDepth(3);

	-- self.transfer:addClickFuntion(self, self.onPointClick);
	-- self.npc:addClickFuntion(self, self.onPointClick);
	-- self.monster:addClickFuntion(self, self.onPointClick);
end

function Lua_SceneMapShowPoint:setDepth(val)
	self:superCall("setDepth");

	self.img:setDepth(val);
	self.point:setDepth(val);
	self.txt:setDepth(val + 1);
end

function Lua_SceneMapShowPoint:setData(data)
	if data == nil then
		return;
	end
	
	if data.data.isConceal == 1 then
		self.txt:setEnable(false)
		self.point:setEnable(false);
		return;
	end
	self.typeName = data.typeName;
	self.data = data.data;
	self.txt:setEnable(true)
	self.point:setEnable(true);

	local str = "";
	if self.data.name ~= nil then
		str = self.data.name;
		if self.data.campId == Lua_CampWarUtil.CAMPWARID_RED then
			if DataCenter.campWarData.bInCampWarScene == true then
				str = "[FF1616][" .. DataCenter.campWarUtil:getCampNameById(self.data.campId) .. "][-]" .. str;
			else
				str = "[FF1616]" .. str .. "[-]";
			end
		elseif self.data.campId == Lua_CampWarUtil.CAMPWARID_BLUE then
			if DataCenter.campWarData.bInCampWarScene == true then
				str = "[55d2ff][" .. DataCenter.campWarUtil:getCampNameById(self.data.campId) .. "][-]" .. str;
			else
				str = "[55d2ff]" .. str .. "[-]";
			end
		end
		self.txt.text = str;
	end
	self.txt:setLocation(0, 26);

	if self.typeName == "exits" then
		self.point:setEnable(true);
		self.point:setAltas("map_atlas", "ui_map_icon_delivery");
		self.point:SetDimensions(28, 28);
		self.img:setEnable(false);
	elseif self.typeName == "teleport" then
		self.point:setEnable(true);
		self.point:setAltas("map_atlas", "ui_map_icon_delivery");
		self.point:SetDimensions(28, 28);
		self.img:setEnable(false);
	elseif self.typeName == "npc" then
		self.point:setEnable(true);
		self.point:setAltas("map_atlas", "ui_map_icon_npc");
		self.point:SetDimensions(32, 32);
		self.img:setEnable(false);

		local obj = getConfig({"monster", self.data.id});
		if obj ~= nil then -- npc
			self.txt.text = (obj.name == nil) and "" or obj.name;
		end
	elseif self.typeName == "monster" then
		self.point:setEnable(true);
		self.point:setAltas("map_atlas", "ui_map_icon_enemy");
		self.point:SetDimensions(32, 32);
		self.img:setEnable(false);

		local obj = getConfig({"monster", self.data.id});
		if obj ~= nil then -- 怪物
			if obj.boss ~= nil and obj.boss == 1 then -- boss
				self.point:setEnable(true);
			else -- 小怪
				self.point:setEnable(true);
			end
			self.txt.text = (obj.name == nil) and "" or obj.name;
		end
	elseif self.typeName == "bornPoint" then -- 出生点
		self.point:setEnable(true);
		self.point:setAltas("map_atlas", "ui_map_icon_birth");
		self.point:SetDimensions(32, 40);
		self.img:setEnable(false);
	elseif self.typeName == "safe" then -- 安全区
		self.point:setEnable(false);

		self.img:setEnable(true);
		if self.data.res_safe ~= nil then
			self.img:setUrl("/maps/"..self.data.res_safe);
			
			local info = self.data.rts_safe;
			if info ~= nil then
				if #info > 3 then
					self.img:setRot(0, 0, info[4])
					if #info > 4 then
						self.img:setSacle(info[5], info[5], info[5]);
					end
				end
			end
		else
			self.img:setEnable(false);
		end

		if self.data.txt_pos ~= nil and #self.data.txt_pos > 1 then
			self.txt:setLocation(self.data.txt_pos[1], self.data.txt_pos[2]);
		end
	end
end

function Lua_SceneMapShowPoint:setShowHunDun(mousterId, gather_id)
	if mousterId == nil and gather_id == nil then
		return;
	end

	if tonumber(mousterId) == tonumber(self.data.id) then
		if tonumber(gather_id) > 0 and DataCenter.bossData.OnUpdataZQ == true then
			if self.zhanqiIcon == nil then
				self.zhanqiIcon = UICreate.createUIAtlasImage(self.content, "", "", 0, 63, 36, 51);
				self.zhanqiIcon:setDepth(10);
			end
			self.zhanqiIcon:setAltas("bossWindow", tostring(gather_id));
			self.zhanqiIcon:setEnable(true);
		elseif self.zhanqiIcon ~= nil then
			self.zhanqiIcon:setEnable(false);
		end
	end
end

function Lua_SceneMapShowPoint:setShowIcon(iconUrl, sizeW, sizeH, txtStr)
	self.typeName = nil;
	self.data = nil;

	self.img:setEnable(false);
	self.point:setEnable(true);

	self.point:setAltas("map_atlas", iconUrl);
	self.point:SetDimensions(sizeW, sizeH);
	self.txt.text = txtStr;
end

function Lua_SceneMapShowPoint:onPointClick(go)
	if self.data ~= nil then
		DataCenter.hook:stop(true);

		local roleId = tonumber(DataCenter.roleData.roleId);
		local ac = WorldMapUtil.genArriveActionVo({type = 10, targetId =  Lua_CommonUtil.trnsLongNum(roleId)});
		WorldMapUtil.moveTo(DataCenter.roleData.sceneId, self.data.posX, self.data.posY, self.data.posZ, 0, 0, ac, 0);
		Lua_MsgUtil.callFunc("SCENEMAP_CANCLE_CLICKFLY", {x = self.data.posX, y = self.data.posY, z = self.data.posZ});
	end
end

function Lua_SceneMapShowPoint:dispose()
	if self.img ~= nil then
		self.img:dispose();
		self.img = nil;
	end
	self:superCall("dispose");
end