Lua_SceneMonsterNoticeTip = class("Lua_SceneMonsterNoticeTip", Lua_DisplayObject)
function Lua_SceneMonsterNoticeTip:ctor(p)
	self:superCall("ctor", p, "SceneMonsterNoticeTip_skin");
end

function Lua_SceneMonsterNoticeTip:buildShowItem()
	self:superCall("buildShowItem");

	self.lvTxt.text = "";
	self.defenceTxt.text = "";
	self.dropTxt.text = "";
	self._height = 0;
	self._width = 378;
	self.txtArr = Array();
end

function Lua_SceneMonsterNoticeTip:getHeight()
	return self._height;
end

function Lua_SceneMonsterNoticeTip:getWidth()
	return self._width;
end

function Lua_SceneMonsterNoticeTip:setData(showVo)
	local txt;
	self._height = 0;
	self._width = 0;
	self.vo = showVo;
	if showVo ~= nil then
		self:setEnable(true);
		
		local maxW = 0;
		if showVo.lv > DataCenter.roleData.level then
			self.lvTxt.text = Lua_ColorDefine.colorStr(LanUtil.formateStr(LanUtil.getValue(123318), tostring(showVo.lv)), Lua_ColorDefine.RED_STR);
		else
			self.lvTxt.text = Lua_ColorDefine.colorStr(LanUtil.formateStr(LanUtil.getValue(123318), tostring(showVo.lv)), Lua_ColorDefine.GREEN_STR);
		end
		if maxW < self.lvTxt.width then
			maxW = self.lvTxt.width;
		end

		if showVo.defence > DataCenter.roleData.defence then
			self.defenceTxt.text = Lua_ColorDefine.colorStr(LanUtil.formateStr(LanUtil.getValue(123319), tostring(showVo.defence)), Lua_ColorDefine.RED_STR);
		else
			self.defenceTxt.text = Lua_ColorDefine.colorStr(LanUtil.formateStr(LanUtil.getValue(123319), tostring(showVo.defence)), Lua_ColorDefine.GREEN_STR);
		end
		if maxW < self.defenceTxt.width then
			maxW = self.defenceTxt.width;
		end
		
		self.dropTxt.text = showVo.dropDesc;
		if maxW < self.dropTxt.width then
			maxW = self.dropTxt.width;
		end

		self._width = maxW + 90;
		self._height = math.abs(self.dropTxt.mainContent.transform.localPosition.y) + self.dropTxt.height + 39;
		self.bg:SetDimensions(self._width, self._height);
        if showVo.canClose ~= nil then
            if self.closeBtn == nil then
                self.closeBtn = UICreate.createUIAtlasImage(self.content,  "mainWindow_atlas", "ui_zhujiemian_widget_gb", self._width, 0, 0, 0);
                self.closeBtn:setDepth(100);
                self.closeBtn:setScale(0.8, 0.8);
                self.closeBtn.name = "colseBtn"
                self.closeBtn:addClickFuntion(self,self.CloseTipsWin);
            else
                self.closeBtn:setLocation(self._width, 0);
                self.closeBtn:setEnable(true);
            end
        else
            if self.closeBtn ~= nil then
                self.closeBtn:setEnable(false);
            end
        end
	else
		self:setEnable(false);
	end
end
function Lua_SceneMonsterNoticeTip:CloseTipsWin()
    self:setEnable(false);
end

function Lua_SceneMonsterNoticeTip:setArrowType(isLeft, isDown)
	local posX = self._width;
	if isLeft == true then
		posX = 0;
	end
	
	local posY = -self._height;
	if isDown ~= true then
		posY = 0;
	end

	local angle = 0;
	if isLeft == true then
		if isDown == true then --左下
			angle = -45;
		else -- 左上
			angle = -135;
		end
	else
		if isDown == true then -- 右下
			angle = 45;
		else --右上
			angle = 135;
		end
	end

	self.arrow:setRot(0, 0, angle);
	self.arrow:setLocation(posX, posY);
	
    if posX == self._width and posY == 0 and self.closeBtn~=nil then
        self.closeBtn:setLocation(0, 0);
    end
end

function Lua_SceneMonsterNoticeTip:dispose()
	self:superCall("dispose");
end